/**
*
* Ares
* (c) 2004 Erik Anderson (Sputnik)
* erik_h_anderson@hotmail.com
*
*
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
* 
*
* Requires CVEL library --                             
* please see ProjectGanymede on SourceForge for the latest source *
*/


#ifndef _CVELTITAN_H_
#define _CVELTITAN_H_


//#include <common_addon_ex.h>
#include "../../include/cvel.h"
#include "../../include/cvelmessage.h"
#include "../../include/guidance.h"
#include <cstdio>

using std::string;

#include "../../include/orbitersdk.h"
#include "../../include/orbitersoundsdk3.h"
//#include "multi_stage2.h"
//#include "../../include/multi_stage2.h"
#include "stdio.h"
#include "math.h"


const double GBOTTOM = -3.09+.75;
const VECTOR3 OFS_GEMINI         = { 0.0, 0.0, 0.75};
const VECTOR3 OFS_GEM_EQUIPMENT  = { 0.0, 0.0, GBOTTOM+.75};
const VECTOR3 OFS_GEM_ADAPTER    = { 0.0, 0.0, OFS_GEM_EQUIPMENT.z-.285+.85+.6};
const VECTOR3 OFS_GEM_CAPSULE    = { 0.0, 0.0, OFS_GEM_ADAPTER.z-.385 +.6+1.43};
const VECTOR3 OFS_GEM_DOOR_LEFT  = { -0.49, 0.647, OFS_GEM_CAPSULE.z-.631};
const VECTOR3 OFS_GEM_DOOR_RIGHT = { 0.479, 0.657, OFS_GEM_CAPSULE.z-.631};
const VECTOR3 OFS_GEM_NOSE       = { 0.0, 0.0, OFS_GEM_CAPSULE.z-.00 + 1.035 +.55};
const VECTOR3 OFS_GEM_CDR        = { -0.5, -0.049, OFS_GEM_CAPSULE.z-.72};
const VECTOR3 OFS_GEM_PLT        = { 0.4 , -0.049, OFS_GEM_CAPSULE.z-.72};
const VECTOR3 OFS_SEAT           = _V(OFS_GEM_PLT.x+.075,OFS_GEM_PLT.y+.125,OFS_GEM_PLT.z-0.05);
const VECTOR3 OFS_GEM_HEATSHIELD = { 0.0, 0.0, OFS_GEM_CAPSULE.z-1.3};


const double  STAGE4_LENGTH       = 3.37;
const VECTOR3 STAGE4_OFS          = { 0.0,  0.0,  GBOTTOM - STAGE4_LENGTH / 2+.02};
//const VECTOR3 STAGE4_OFS          = { 0.0,  0.0, -3.05-STAGE4_LENGTH / 2};
const VECTOR3 STAGE4_OFS_FLAME_UP = { 0.0,  0.7,  STAGE4_OFS.z-2.25};
const VECTOR3 STAGE4_OFS_FLAME_DN = { 0.0, -0.7,  STAGE4_OFS.z-2.25};


const double  STAGE3_LENGTH       = 3.38;
const VECTOR3 STAGE3_OFS          = { 0.0,  0.0,  GBOTTOM - STAGE3_LENGTH / 2+.02};
//const VECTOR3 STAGE3_OFS          = { 0.0,  0.0,  STAGE4_OFS.z - STAGE4_LENGTH / 2 - STAGE3_LENGTH / 2 + .53};
const VECTOR3 STAGE3_OFS_FLAME_UP = { 0.0,  0.7,  STAGE3_OFS.z-.25};
const VECTOR3 STAGE3_OFS_FLAME_DN = { 0.0, -0.7,  STAGE3_OFS.z-.25};

const VECTOR3 TRANSTAGE_OFS      = { 0.0, 0.0, -2.1};
const VECTOR3 INTERSTAGE2_OFS    = { 0.0, 0.0, -3.75};
const VECTOR3 CENTAUR_OFS        = { 0.0, 0.0, -0.6};
const VECTOR3 AGENA_OFS        = { 0.0, 0.0, -1.0};
const VECTOR3 CHARIOT_OFS      = { 0.0, 0.0, -2.1};

const double STAGE2_LENGTH       = 9.54;
const double STAGE2_LEN_ENGINE   = 1.41;
const VECTOR3 STAGE2_OFS         = { 0.0     , 0.0     ,  STAGE3_OFS.z - STAGE3_LENGTH / 2 - STAGE2_LENGTH / 2 + .8};
const VECTOR3 STAGE2_OFS_FLAME  = { 0.0     , 0.0     ,  STAGE2_OFS.z-STAGE2_LENGTH/2};
const VECTOR3 STAGE2_FLAME_DIR   = { 0.0, 0.0, 1.0};

const double MID_LENGTH          = 3.17;
const VECTOR3 MID_OFS            = { 0.     , 0.0     , STAGE2_OFS.z - STAGE2_LENGTH / 2 + STAGE2_LEN_ENGINE - MID_LENGTH / 2};

const double  STAGE1_LENGTH      = 22.00;
const VECTOR3 STAGE1_OFS         = {  0.0     , 0.0     , MID_OFS.z - MID_LENGTH / 2 - STAGE1_LENGTH / 2 +.1};
const VECTOR3 STAGE1_OFS_FLAME   = {  0.0     , 0.0     , STAGE1_OFS.z-STAGE1_LENGTH/2};
const VECTOR3 STAGE1_OFS1_FLAME  = {  0.7     , 0.0     , STAGE1_OFS.z-STAGE1_LENGTH/2 + .6};
const VECTOR3 STAGE1_OFS2_FLAME  = { -0.7     , 0.0     , STAGE1_OFS.z-STAGE1_LENGTH/2 + .6};
const VECTOR3 T3_OFS1_FLAME  = {  0.0     , 0.7     , STAGE1_OFS.z-STAGE1_LENGTH/2 + .6};
const VECTOR3 T3_OFS2_FLAME  = {  0.0     ,-0.7     , STAGE1_OFS.z-STAGE1_LENGTH/2 + .6};
const VECTOR3 STAGE1_FLAME_DIR   = {  0.0     , 0.0     , 1.0};

const VECTOR3 STAGE0_OFS_LEFT        = { -1.55-1.5, 0.0, STAGE1_OFS.z+1.5};
const VECTOR3 STAGE0_OFS_RIGHT       = {  1.55+1.5, 0.0, STAGE1_OFS.z+1.5};
const VECTOR3 STAGE0_OFS_LEFT_FLAME  = { -1.55-1.5, 0.0, STAGE1_OFS.z-11.5};
const VECTOR3 STAGE0_OFS_RIGHT_FLAME = {  1.55+1.5, 0.0, STAGE1_OFS.z-11.5};
const VECTOR3 RSRM_OFS_LEFT        = { -1.97-1.5, 0.0, STAGE1_OFS.z-1.5};
const VECTOR3 RSRM_OFS_RIGHT       = {  1.97+1.5, 0.0, STAGE1_OFS.z-1.5};
const VECTOR3 RSRM_OFS_LEFT_FLAME  = { -1.97-1.5, 0.0, STAGE1_OFS.z-24.5};
const VECTOR3 RSRM_OFS_RIGHT_FLAME = {  1.97+1.5, 0.0, STAGE1_OFS.z-24.5};

const VECTOR3 SRM0_OFS		         = { -0.606, 1.96, STAGE1_OFS.z-3.5};
const VECTOR3 SRM1_OFS		         = {  0.606,-1.96, STAGE1_OFS.z-3.5};
const VECTOR3 SRM2_OFS		         = { -0.606,-1.96, STAGE1_OFS.z-3.5};
const VECTOR3 SRM3_OFS		         = {  0.606, 1.96, STAGE1_OFS.z-3.5};
const VECTOR3 SRM4_OFS		         = { -1.64, 1.23, STAGE1_OFS.z-3.5};
const VECTOR3 SRM5_OFS		         = {  1.64,-1.23, STAGE1_OFS.z-3.5};
const VECTOR3 SRM6_OFS		         = { -1.64,-1.23, STAGE1_OFS.z-3.5};
const VECTOR3 SRM7_OFS		         = {  1.64, 1.23, STAGE1_OFS.z-3.5};
const VECTOR3 SRM8_OFS		         = { -2.04,-0.0,  STAGE1_OFS.z-3.5};
const VECTOR3 SRM9_OFS		         = {  2.04, 0.0, STAGE1_OFS.z-3.5};

//const VECTOR3 OFS_MAINTANK = { 0, 0, -15.0}; 
const VECTOR3 OFS_GEM1 = { 6.4, -2.55, -34.3};    
const VECTOR3 OFS_GEM2 = { -6.4, -2.55, -34.3};   
//const VECTOR3 OFS_SRM1 = { 6.4, 0, -25.8};    
//const VECTOR3 OFS_SRM2 = { -6.4, 0, -25.8};    
//const VECTOR3 OFS_ENGMOD = { 0, 5.75, -31.615};  
//const VECTOR3 OFS_UPPRSTG  = { 0.0, 0.0, 10.0};  
const VECTOR3 OFS_SHROUD1 = { -.002, 0.0, 0.0};  
const VECTOR3 OFS_SHROUD2 = { .002, 0.0, 0.0}; 
const VECTOR3 OFS_SHROUD3 = { 0.0, 0.0, 0.0};

const double KG = 1.0;
const double SEC = 9.81;
const double KGF = 9.81;
//const double MASS_FOURTH   = 12247*KG;
//const double MASS_THIRD    = 12247*KG;
const double MASS_SECOND   = 29188*KG;
//const double MASS_FIRST    = 116573*KG;
const double MASS_SECONDC  =  57400*KG;
const double MASS_SECOND45 =  39500*KG;
const double MASS_FIRST45  = 163000*KG;
const double MASS_SECOND34 =  37650*KG;
const double MASS_FIRST34  = 139935*KG;
const double MASS_SECOND23 =  28939*KG;
const double MASS_FIRST23  = 117866*KG;
const double MASS_SECOND1  =  28939*KG;
const double MASS_FIRST1   =  76203*KG;
const double MASS_UA1003   = 115350*KG;
const double MASS_UA1205   = 226233*KG;
const double MASS_UA1207   = 315646*KG;
const double MASS_UA1208   = 360738*KG;
const double MASS_SRMU     = 349600*KG;
const double MASS_CASTOR   =  13600*KG;
const double MASS_ALGOL    =  11600*KG;



//const double MASS_FOURTH_EMPTY   = 1950*KG;
//const double MASS_FOURTH_FUEL    = MASS_FOURTH-MASS_FOURTH_EMPTY;
//const double MASS_THIRD_EMPTY   = 1950*KG;
//const double MASS_THIRD_FUEL    = MASS_THIRD-MASS_THIRD_EMPTY;


const double MASS_SECOND1_EMPTY  = 1725*KG;
const double MASS_SECOND1_FUEL   = MASS_SECOND1-MASS_SECOND1_EMPTY;
const double MASS_FIRST1_EMPTY   = 4000*KG;
const double MASS_FIRST1_FUEL    = MASS_FIRST1-MASS_FIRST1_EMPTY;
const double MASS_SECOND23_EMPTY  = 2404*KG;
const double MASS_SECOND23_FUEL   = MASS_SECOND23-MASS_SECOND23_EMPTY;
const double MASS_FIRST23_EMPTY   = 4443*KG;
const double MASS_FIRST23_FUEL    = MASS_FIRST23-MASS_FIRST23_EMPTY;

const double MASS_SECONDC_EMPTY   = 5704*KG;
const double MASS_SECONDC_FUEL    = MASS_SECONDC-MASS_SECONDC_EMPTY;

const double MASS_SECOND34_EMPTY  = 2900*KG;
const double MASS_SECOND34_FUEL   = MASS_SECOND34-MASS_SECOND34_EMPTY;
const double MASS_FIRST34_EMPTY   = 6900*KG;
const double MASS_FIRST34_FUEL    = MASS_FIRST34-MASS_FIRST34_EMPTY;

const double MASS_SECOND45_EMPTY  = 4500*KG;
const double MASS_SECOND45_FUEL   = MASS_SECOND45-MASS_SECOND45_EMPTY;
const double MASS_FIRST45_EMPTY   = 7900*KG;
const double MASS_FIRST45_FUEL    = MASS_FIRST45-MASS_FIRST45_EMPTY;

const double MASS_UA1003_EMPTY    = 12000*KG;
const double MASS_UA1003_FUEL     = MASS_UA1003-MASS_UA1003_EMPTY;
const double MASS_UA1205_EMPTY    = 33798*KG;
const double MASS_UA1205_FUEL     = MASS_UA1205-MASS_UA1205_EMPTY;
const double MASS_UA1207_EMPTY    = 43537*KG;
const double MASS_UA1207_FUEL     = MASS_UA1207-MASS_UA1207_EMPTY;
const double MASS_UA1208_EMPTY    = 47890*KG;
const double MASS_UA1208_FUEL     = MASS_UA1208-MASS_UA1208_EMPTY;
const double MASS_SRMU_EMPTY      = 52040*KG;
const double MASS_SRMU_FUEL       = MASS_SRMU-MASS_SRMU_EMPTY;
const double MASS_CASTOR_EMPTY    = 1350*KG;
const double MASS_CASTOR_FUEL     = MASS_CASTOR-MASS_CASTOR_EMPTY;
const double MASS_ALGOL_EMPTY     = 1650*KG;
const double MASS_ALGOL_FUEL      = MASS_ALGOL-MASS_ALGOL_EMPTY;
const double MASS_RSRM_EMPTY	  = 87543.0;
const double MASS_RSRM_FUEL		  = 502126.0;
const double MASS_RSRM			  = MASS_RSRM_EMPTY + MASS_RSRM_FUEL;

const double ISP_UA1003_SL   = 235*SEC;
const double ISP_UA1003_VAC  = 260*SEC;
const double ISP_UA1205_SL   = 238*SEC;
const double ISP_UA1205_VAC  = 263*SEC;
const double ISP_SRMU_SL     = 240*SEC;
const double ISP_SRMU_VAC    = 265*SEC;
const double ISP_FIRST1_SL   = 256*SEC;
const double ISP_FIRST1_VAC  = 290*SEC;
const double ISP_FIRST_SL    = 258*SEC;
const double ISP_FIRST_VAC   = 296*SEC;
const double ISP_FIRST34_SL  = 250*SEC;
const double ISP_FIRST34_VAC = 302*SEC;
const double ISP_SECOND1_SL  = 210*SEC;
const double ISP_SECOND1_VAC = 308*SEC;
const double ISP_SECOND_SL   = 160*SEC;
const double ISP_SECOND_VAC  = 316*SEC;
const double ISP_SECOND34_SL = 160*SEC;
const double ISP_SECOND34_VAC= 316*SEC;
const double ISP_C_SL        = 350*SEC;
const double ISP_C_VAC       = 413*SEC;
const double ISP_THIRD_SL    =   0*SEC;
const double ISP_THIRD_VAC   = 311*SEC;
const double ISP_FOURTH_SL   =   0*SEC;
const double ISP_FOURTH_VAC  = 311*SEC;
const double ISP_CASTOR_SL   = 242*SEC;
const double ISP_CASTOR_VAC  = 265*SEC;
const double ISP_ALGOL_SL    = 232*SEC;
const double ISP_ALGOL_VAC   = 255*SEC;
const double ISP_RSRM_VAC	 = 3574.68;
const double ISP_RSRM_SL	 = 2859.74;


const double THRUST_UA1003_VAC  = 339505*KGF;
const double THRUST_UA1205_VAC  = 596474*KGF;
const double THRUST_UA1207_VAC  = 713557*KGF;
const double THRUST_UA1208_VAC  = 815493*KGF;
const double THRUST_SRMU_VAC    = 780020*KGF;
const double THRUST_FIRST1_VAC  = 215140*KGF/2.0;
const double THRUST_SECOND1_VAC =  36288*KGF;
const double THRUST_FIRST_VAC   = 212827*KGF/2.0;		// LR87-AJ-7 figures
const double THRUST_FIRST34_VAC = 238590*KGF/2.0;		// LR87-AJ-11 figures
const double THRUST_SECOND_VAC  =  45351*KGF;			// LR91-AJ-7 figures
const double THRUST_SECOND34_VAC=  46848*KGF;			// LR91-AJ-11 figures
const double THRUST_C_VAC	    =  68500*KGF;
const double THRUST_THIRD_VAC   =   3628*KGF;
const double THRUST_FOURTH_VAC  =   3628*KGF;
const double THRUST_CASTOR_VAC  =  52500*KGF;
const double THRUST_ALGOL_VAC   =  57537*KGF;
const double THRUST_RSRM_VAC	= 1202020.0*9.81 * 1.25;

const double ISP_TRANSTAGE_SL		=     316.0*G; 
const double ISP_TRANSTAGE_VAC		=     316.0*G; //***
const double THRUST_TRANSTAGE_VAC	=    7485.0*G; //***
const double MAX_ATT_TRANSTAGE		=     250.0*G;
const double TRANSTAGE_PROP_MASS	=   10297.0; //*** the total mass of fueled Transtage is 12247kg
const double TRANSTAGE_MAX_BURN		=     625.0; //***
const double TRANSTAGE_DRYMASS		=    1950.0; //***

const double ISP_CENTAUR_SL		=     444.0*G; 
const double ISP_CENTAUR_VAC		=     444.0*G; //***
const double THRUST_CENTAUR_VAC	=    7485.0*G; //***
const double MAX_ATT_CENTAUR		=     250.0*G;
const double CENTAUR_PROP_MASS	=   13900.0; //*** the total mass of fueled CentaurD is 15600kg
const double CENTAUR_MAX_BURN	=     625.0; //***
const double CENTAUR_DRYMASS	=    1700.0; //***

const double ISP_AGENA_SL		=     296.0*G; 
const double ISP_AGENA_VAC		=     296.0*G; //***
const double THRUST_AGENA_VAC	=    9740.0*G; //***
const double MAX_ATT_AGENA		=     250.0*G;
const double AGENA_PROP_MASS	=   12000.0; //*** the total mass of fueled AGENA is 18318kg
const double AGENA_MAX_BURN		=     625.0; //***
const double AGENA_DRYMASS		=    1950.0; //***

const double ISP_CHARIOT_SL		=     365.0*G; 
const double ISP_CHARIOT_VAC	=     422.0*G; //***
const double THRUST_CHARIOT_VAC	=   15590.0*G; //***
const double MAX_ATT_CHARIOT	=     250.0*G;
const double CHARIOT_PROP_MASS	=   16200.0; //*** the total mass of fueled CHARIOT is 18000kg
const double CHARIOT_MAX_BURN	=     625.0; //***
const double CHARIOT_DRYMASS	=    1800.0; //***

#define PLAYBANG					 24		// the jettison sound
#define PLAYABORT					 25		// the abort sound



class CVELTITAN : public COMMON_VESSEL_EX, GUIDANCE {
public:
	enum SRMType { NONE, UA1003, UA1205A, UA1205, UA1207, UA1208, SRMU, RSRM } SRM_Type;
	CVELTITAN (OBJHANDLE hObj, int fmodel);
	~CVELTITAN();
	void SetBoosters();
	void VectorThrust();
//	void SetAttControlsSecond();
//	void SetGEMsStage ();
	void MakeSRMs ();
	void StageSRMs ();
	void CalcWeights ();
	void SetClusterStage();
	void SetSRMsStage ();
	void SetMainStage();
	void SetNoFairStage ();
	void SetSecondStage ();
	void SetUpperStage ();
	void SeparateStage (UINT stage);
	void JettisonLES();
	void DeployAPayload();
	void ProgramAuto();
	void SetAStage();
	int ConsumeBufferedKey(DWORD dwKey, bool fPressed, const char *keystate);
	void SetClassCaps(  FILEHANDLE cfg );
	void TimeStep( double simt );

	void VisualCreated( VESSEL *vessel, VISHANDLE vis, int refcount );
	void PlaceComponents();
	void LoadState(  FILEHANDLE scn, void *vs );
	void SaveState(  FILEHANDLE scn );
	bool AzInput (void *id, char *str, void *data);
	bool IncInput (char *rstr);


	double pitchinput, yawinput, rollinput;
	double timebias, padbias, RCSmass;
	VESSELSTATUS2 vst;
	int fairing;
	VECTOR3 ofs_shroud1, ofs_shroud2, ofs_shroud3;

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);

protected:
	double GetCPitch(double t);
	void Lateral_Guidance(VESSEL *vessel, double SimT, double SimT_Last);
	void Guidance_Routine(VESSEL *vessel, double SimT, double SimT_Last);
	void GetInclinationSP();
	void InitialiseGuidance();


	bool Guidance() { return guidance; };
	void Guidance( bool g ) { guidance = g; };

	void DisplayInclinationSetPoint( bool d ) { DisplayIncSP=d; };
	bool DisplayInclinationSetPoint() { return DisplayIncSP; };

	void ManualSeparate( bool m ) { bManualSeparate = m; };
	bool ManualSeparate() { return bManualSeparate; };

	double initialgamma, initialheading, launchrotate;
	bool Titan3, Titan2, Titan34, Titan3M, Titan4, TitanC, Titan1, Cluster, EnginesVert, SSTOcase, BoostersSet, SecondStageRCS;
	VECTOR3 stage0_ofs_left, stage0_ofs_right,stage0_ofs_left_flame,stage0_ofs_right_flame;

	double SRMBias, SRMExhBias;
	bool vectorme;
	int MyID;

	PROPELLANT_HANDLE ph_SRMs0, ph_SRMs1, ph_first, ph_main, ph_second, ph_GEMs, ph_RCS, ph_upper;	
	THRUSTER_HANDLE th_SRMs[10];
	THRUSTER_HANDLE th_first[8];
	THRUSTER_HANDLE th_sep[12];
	THRUSTER_HANDLE th_srb[4];
	THRUSTER_HANDLE th_main[4];
	THRUSTER_HANDLE th_second[2];   
	THRUSTER_HANDLE th_upper[2];
	THGROUP_HANDLE thg_SRMs;
	THGROUP_HANDLE thg_srb; 
	THGROUP_HANDLE thg_first; 
	THGROUP_HANDLE thg_main; 
	THGROUP_HANDLE thg_second;  
	THGROUP_HANDLE thg_upper;  
	THGROUP_HANDLE thg_pitchup;
	THGROUP_HANDLE thg_pitchdown;

	int refcount;
	MESHHANDLE hCluster, hClusterInt;
	MESHHANDLE hFirstStage;
	MESHHANDLE hInterStage;
	MESHHANDLE hshroud1;
	MESHHANDLE hshroud2, hshroud3;
	MESHHANDLE hsrm1;
	MESHHANDLE hsrm2;
	MESHHANDLE hSRM0, hSRM1, hSRM2, hSRM3, hSRM4, hSRM5, hSRM6, hSRM7, hSRM8, hSRM9;
	MESHHANDLE hGEM;
	MESHHANDLE hSecondStage;
	MESHHANDLE hTranstage, hCentaur, hAgena, hChariot;
	MESHHANDLE hInterStage2, hInterStage2b, hInterStage2c;
	MESHHANDLE 	hGemEquip,hGemAdapt,hGemCapsule,hGemHeatshield,hGemCdrSeat,hGemPltSeat,hGemDoorL,hGemDoorR,hGemNose;

	bool bManualSeparate;
	bool bThrustTerm, bAborting;
	double stage_sep;
	UINT stage;
	int status;
	bool ignition;
	double time;
	char pay_name[256];
	char pay_mesh_name[256];
	double pay_mass;
	bool autopilot;
	bool engineignited;
	double last_simt;
	double ignition_time;
	double density;
	double tempP, tempY, tempR;
	VECTOR3 AngularVel;
	bool havesound, firsttime, invoked;
	double srm_prop_mass, isp_srm_sl, isp_srm_vac, isp_main_sl, isp_main_vac, isp_second_sl, isp_second_vac;
	double thrust_srm_vac, thrust_main_vac, thrust_second_vac, mass_srms;
	bool autoLEO;
	int SecndS;
	int deployed, shiftfocus, UprS;
	VESSEL *depV, *SRM1, *SRM2, *AtchV;
	OBJHANDLE hV, hVessel, hanSRM1, hanSRM2;
	PROPELLANT_HANDLE ph_SRM1, ph_SRM2;
	bool bswitchfocus, bsolidsfired, ClusterDecreased;
	double mass_first_fuel,mass_first_empty,mass_first,mass_second_fuel,mass_second_empty,mass_second,mass_fairing;
	int DrawAGemini;
	double GeminiZ, Uppermass;
	double displaytime, LaunchMJD, simt, oldsimt, dt, d_heading, screenheight;
	double Stg0Longer, Stg1Longer, Stg1Bias, Stg2Longer, Stg2Bias, Stg2EngBias;
	double LastDeployed;
	bool first_guidance_pass,deploy_no_more,bgoingsouth,bjustseparated, stg1invoked;
	int numSRMs0, numSRMs1;
	VECTOR3 OFFSIDEL, OFFSIDER;
	ATTACHMENTHANDLE  attachpos, tgtatch;
	VECTOR3           attach;
	VECTOR3			  attachdir;
	VECTOR3           attachrot;
	char tgtname[31];
	VECTOR3				tgtpos, tgtrot, CAMERA_OFS;
	bool Firstsweep, Flydown;
	double atchmass;
	double LEStime;
	int mode;
	VECTOR3 horiz;
	char *key;
	char *message;
	double OutBias;



};

#endif
